function TrainData = Boosting(PosData, NegData, T)

W=19; H=19;
np = size(PosData.feat, 1);
nn = size(NegData.feat, 1);

ys = [ones(np, 1); zeros(nn, 1)];
ws = [ones(np, 1)/(2*np); ones(nn, 1)/(2*nn)];

alphas = zeros(T, 1);
Thetas = zeros(T, 3);
feat = [PosData.feat; NegData.feat];
for t=1:T
    ws = ws / sum(ws);
    [theta, p, err] = LearnThreshClassifier(ws, feat, ys);
    [val, j] = min(err);
    e = err(j);
    beta = e/(1-e);
    hs = p(j).*feat(:,j) < p(j).*theta(j);
    wsu = (beta.^(1-abs(hs-ys)));
    Thetas(t,:) = [j, theta(j), p(j)];
    alphas(t) = log(1/beta);
    ws = ws .* wsu;
    disp(sprintf('Boosting iteration %d complete', t));
end

TrainData.alphas = alphas;
TrainData.Thetas = Thetas;
TrainData.featMat = PrepareFeatMat(PosData.featTypes(Thetas(:,1),:),W,H);
TrainData.featTypes = PosData.featTypes;
