function newDet = DetectFace(TrainData, im, min_scale,max_scale)
W=19; H=19;
threshold = TrainData.thresh;
featMat = TrainData.featMat';
alphas = TrainData.alphas';
theta = TrainData.Thetas(:,2);
p = TrainData.Thetas(:,3);
pTheta = p.*theta;

SSTEP = .1;
SAMPLE_RATE = 1;
EDGE = 25;
sz = [W H];
im = double(im);
detections= [];
for s= min_scale:SSTEP:max_scale
    ims = imresize(im,s);
    for indY=EDGE :SAMPLE_RATE:size(ims,1)- EDGE
        for indX=EDGE:SAMPLE_RATE:size(ims,2) - EDGE
            
            limy = indY-floor(H/2):indY+floor(H/2);
            limx = indX-floor(W/2):indX+floor(W/2);
            
            imw = ims(limy,limx);
            m = mean(imw(:));
            stnd = std(imw(:));
            if stnd > 20
                imw = (imw-m)/stnd;
                iImw = cumsum(cumsum(imw),2);
                
                fs = featMat * iImw(:);
                Score = alphas*(p.*fs<pTheta);
                if Score>threshold
                    scaleddetloc = [limy(1) limx(1) sz(1) sz(2) Score]./s;
                    detections = [detections;scaleddetloc];
                end
            end;
        end;
    end;
end;


% prune detections
% if detections are too close, take the higest score
newDet = [];
DTHRESH = 40;
added = [];
visited = [];
for i=1:size(detections,1)
    d1 = detections(i,1:2);
    if isempty(find(visited==i)) || ~isempty(find(added==i))
        
        d1rep = repmat(d1,[size(detections,1) 1]);
        dis = sqrt(sum((detections(:,1:2) - d1rep).^2,2));
        ind = find( dis <=  DTHRESH);
        
        sc = detections(ind,end);
        [val,pos] = max(sc);
        
        % add if it is not close to previuosly added one
        no = ind(pos);
        tmpdet = detections(added,:);
        da = detections(no,1:2);
        darep = repmat(da,[size(tmpdet,1) 1]);
        dis = sqrt(sum((tmpdet(:,1:2) - darep).^2,2));
        if isempty(find( dis <=  DTHRESH));
            newDet = [newDet; detections(ind(pos),:)];
            added = [added no];
        end
        visited = [visited ind'];
    end;
end

% plot detections
figure(1),clf;
imshow(im,[]);
hold on;
for i =1:size(newDet,1)
    rectangle('Position',[newDet(i,2) newDet(i,1) newDet(i,3) newDet(i,4)],'EdgeColor','b','LineWidth',2);
end;