function [PosData,NegData]=GetTrainData(posPath, negPath,featTypes)
W = 19; H = 19;

%% Positive 
im_files = dir([posPath, '*.pgm']);
noIm = length(im_files);
iImgs = zeros(noIm, W*H);
for i=1:noIm
    [im, iIm] = ReadImgIntegral([posPath, im_files(i).name]);
    iImgs(i,:) = iIm(:)';
end
featMat = PrepareFeatMat(featTypes, W, H);
feat = iImgs * featMat;

% save
PosData = [];
PosData.posPath = posPath;
PosData.feat = feat;
PosData.featTypes = featTypes;
save('PosData.mat', 'PosData');

%% Negative 
im_files = dir([negPath, '*.pgm']);
noIm = length(im_files);
iImgs = zeros(noIm, W*H);
for i=1:noIm
    [im, iIm] = ReadImgIntegral([negPath, im_files(i).name]);
    iImgs(i,:) = iIm(:)';
end
featMat = PrepareFeatMat(featTypes, W, H);
feat = iImgs * featMat;

% save
NegData = [];
NegData.posPath = negPath;
NegData.feat = feat;
NegData.featTypes = featTypes;
save('NegData.mat', 'NegData');
