function [theta, p, err] = LearnThreshClassifier(ws, feat, ys)
nof = size(feat, 2);
theta = [];
p = [];
err = [];

ysl = logical(ys);
wspos = ws;
wspos(~ysl) = 0;
wsneg = ws;
wsneg(ysl) = 0;

Tp = sum(wspos);
Tn = sum(wsneg);

for i=1:nof
    fsi = feat(:,i);
    
    [fsis,idx] = sort(fsi);
    
    Spc = cumsum(wspos(idx));
    Snc = cumsum(wsneg(idx));
    
    [emin,eminInd] =  min(min(Spc + (Tn - Snc),Snc + (Tp - Spc)));
    
% non-vectorized version - slower but easier to understand)
%     for j=1:length(idx)
%         Sp = sum(wspos(idx(1:j)));
%         Sn = sum(wsneg(idx(1:j)));
%         
%         e = min(Sp + (Tn - Sn),Sn + (Tp - Sp));
%         
%         if e< emin
%             emin = e;
%             eminInd = j;
%         end;
%     end
    theta(i) = fsis(eminInd);
    
    p(i)=1;
    err(i)= sum(ws.*abs((p(i).*fsi<p(i).*theta(i)) - ys));
    
    etmp = sum(ws.*abs((-1.*fsi<-1.*theta(i)) - ys));
    if etmp < err(i)
        p(i)=-1;
        err(i) = etmp;
    end;
end;
