% Omar Oreifej, 12-07-2010
% Test boosted features for face detection on cropped images
PATH_TEST_POS = 'C:\Research\FaceDetection\Data\MIT\face.test\test\face\';
PATH_TEST_NEG = 'C:\Research\FaceDetection\Data\MIT\face.test\test\non-face\sub\';

testP = dir([PATH_TEST_POS '*.pgm']);
testN = dir([PATH_TEST_NEG '*.pgm']);
C = [10,100,200];% try different number of features
TPs = [];
FPs = [];
TNs = [];
FNs = [];
for indC=1:length(C)
    load(sprintf('TrainData%d.mat',C(indC)));
    
    %% Testing
    ScoresP = [];
    for i=1:length(testP)
        imo = imread([PATH_TEST_POS '\' testP(i).name]);
        Score = EvaluateBox(TrainData,imo);
        ScoresP(i) = Score;
    end;
    
    ScoresN = [];
    for i=1:length(testN)
        imo = imread([PATH_TEST_NEG '\' testN(i).name]);
        Score = EvaluateBox(TrainData,imo);
        ScoresN(i) = Score;
    end;
    
    % ROC CURVE
    TP = [];
    FP = [];
    TN = [];
    FN = [];
    count = 1;
    for Thresh=0:1:62
        TP(count) = length(find(ScoresP>=Thresh));
        FN(count) = length(find(ScoresP<Thresh));
        TN(count) = length(find(ScoresN<Thresh));
        FP(count) = length(find(ScoresN>=Thresh));
        count = count + 1;
    end;
    
    TPs = [TPs; TP];
    FPs = [FPs; FP];
    FNs = [FNs; FN];
    TNs = [TNs; TN];
end

TPR = TPs./(TPs+FNs);
FPR = FPs./(FPs+TNs);
figure(1),clf,hold on;
xlabel('False Alarm Rate');
ylabel('Detection Rate');
plot(FPR',TPR','LineWidth',2.5);
legend('Boosting-10 features','Boosting-100 features','Boosting-200 features','Location','SouthEast');
xlim([0 1]);
ylim([0 1]);
